[packages/zoxide] new

atler atler at pld-linux.org
Thu Jul 29 16:37:03 CEST 2021


commit 0dc3cd0e88658333c1e8a64f464790582d227865
Author: Jan Palus <atler at pld-linux.org>
Date:   Thu Jul 29 16:35:00 2021 +0200

    new

 create-crates.sh |  69 ++++++++++++++++++++++++++++++++++
 zoxide.spec      | 112 +++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 181 insertions(+)
---
diff --git a/zoxide.spec b/zoxide.spec
new file mode 100644
index 0000000..dcf0c22
--- /dev/null
+++ b/zoxide.spec
@@ -0,0 +1,112 @@
+%define		crates_ver	0.7.2
+
+Summary:	A smarter cd command
+Name:		zoxide
+Version:	0.7.2
+Release:	1
+License:	MIT
+Group:		Applications
+Source0:	https://github.com/ajeetdsouza/zoxide/archive/v%{version}/%{name}-%{version}.tar.gz
+# Source0-md5:	3b0a8402ca8d979d52af8761acf4f26d
+# ./create-crates.sh
+Source1:	%{name}-crates-%{crates_ver}.tar.xz
+# Source1-md5:	d7cf9686dc7cd1fda2fb356b7161ac1a
+URL:		https://github.com/ajeetdsouza/zoxide
+BuildRequires:	cargo
+BuildRequires:	rpmbuild(macros) >= 2.004
+BuildRequires:	rust
+BuildRequires:	tar >= 1:1.22
+BuildRequires:	xz
+ExclusiveArch:	%{rust_arches}
+BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)
+
+%description
+zoxide is a blazing fast replacement for your cd command, inspired by
+z and z.lua. It keeps track of the directories you use most
+frequently, and uses a ranking algorithm to navigate to the best
+match.
+
+%package -n bash-completion-zoxide
+Summary:	bash-completion for zoxide
+Group:		Applications/Shells
+Requires:	%{name} = %{version}-%{release}
+Requires:	bash-completion >= 2.0
+BuildArch:	noarch
+
+%description -n bash-completion-zoxide
+This package provides bash-completion for zoxide.
+
+%package -n fish-completion-zoxide
+Summary:	Fish completion for zoxide command
+Group:		Applications/Shells
+Requires:	%{name} = %{version}-%{release}
+Requires:	fish
+BuildArch:	noarch
+
+%description -n fish-completion-zoxide
+Fish completion for zoxide command.
+
+%package -n zsh-completion-zoxide
+Summary:	Zsh completion for zoxide command
+Group:		Applications/Shells
+Requires:	%{name} = %{version}-%{release}
+Requires:	zsh
+BuildArch:	noarch
+
+%description -n zsh-completion-zoxide
+Zsh completion for zoxide command.
+
+%prep
+%setup -q -a1
+
+%{__mv} zoxide-%{crates_ver}/* .
+sed -i -e 's/@@VERSION@@/%{version}/' Cargo.lock
+
+# use our offline registry
+export CARGO_HOME="$(pwd)/.cargo"
+
+mkdir -p "$CARGO_HOME"
+cat >.cargo/config <<EOF
+[source.crates-io]
+registry = 'https://github.com/rust-lang/crates.io-index'
+replace-with = 'vendored-sources'
+
+[source.vendored-sources]
+directory = '$PWD/vendor'
+EOF
+
+%build
+export CARGO_HOME="$(pwd)/.cargo"
+
+%cargo_build --frozen
+
+%install
+rm -rf $RPM_BUILD_ROOT
+export CARGO_HOME="$(pwd)/.cargo"
+
+%cargo_install --frozen --root $RPM_BUILD_ROOT%{_prefix} --path $PWD
+%{__rm} $RPM_BUILD_ROOT%{_prefix}/.crates*
+
+install -Dp contrib/completions/zoxide.bash $RPM_BUILD_ROOT%{bash_compdir}/zoxide
+install -Dp contrib/completions/zoxide.fish $RPM_BUILD_ROOT%{fish_compdir}/zoxide.fish
+install -Dp contrib/completions/_zoxide $RPM_BUILD_ROOT%{zsh_compdir}/_zoxide
+
+%clean
+rm -rf $RPM_BUILD_ROOT
+
+%files
+%defattr(644,root,root,755)
+%doc CHANGELOG.md README.md
+%attr(755,root,root) %{_bindir}/zoxide
+
+%files -n bash-completion-zoxide
+%defattr(644,root,root,755)
+%{bash_compdir}/zoxide
+
+%files -n fish-completion-%{name}
+%defattr(644,root,root,755)
+%{fish_compdir}/zoxide.fish
+
+%files -n zsh-completion-%{name}
+%defattr(644,root,root,755)
+%{zsh_compdir}/_zoxide
diff --git a/create-crates.sh b/create-crates.sh
new file mode 100755
index 0000000..297913a
--- /dev/null
+++ b/create-crates.sh
@@ -0,0 +1,69 @@
+#!/bin/sh
+
+for cmd in bsdtar rpm-specdump cargo perl; do
+  if ! command -v $cmd > /dev/null 2> /dev/null; then
+    not_installed="$not_installed$cmd "
+  fi
+done
+
+if [ -n "$not_installed" ]; then
+  echo "ERROR: required commands not found: $not_installed" >&2
+  exit 1
+fi
+
+pkg_dir=$(readlink -f $(dirname "$0"))
+pkg_name=$(basename "$pkg_dir")
+
+if [ ! -f "$pkg_dir/$pkg_name.spec" ]; then
+  echo "ERROR: unable to determine package name" >&2
+  exit 1
+fi
+
+spec_dump=$(rpm-specdump "$pkg_dir/$pkg_name.spec")
+pkg_version=$(echo "$spec_dump" | grep PACKAGE_VERSION | cut -f3 -d' ')
+pkg_src=$(basename $(echo "$spec_dump" | grep SOURCEURL0 | cut -f3- -d' '))
+crates_file="$pkg_name-crates-$pkg_version.tar.xz"
+cargo_package=${force_cargo_package:-$pkg_name}
+
+if [ -e "$pkg_dir/$crates_file" ]; then
+  echo "ERROR: crates file $crates_file already exists" >&2
+  exit 1
+fi
+
+if [ ! -f "$pkg_dir/$pkg_src" ]; then
+  echo "ERROR: source file $pkg_src not found" >&2
+  exit 1
+fi
+
+tmpdir=$(mktemp -d)
+
+rm_tmpdir() {
+  if [ -n "$tmpdir" -a -d "$tmpdir" ]; then
+    rm -rf "$tmpdir"
+  fi
+}
+
+trap rm_tmpdir EXIT INT HUP
+
+cd "$tmpdir"
+bsdtar xf "$pkg_dir/$pkg_src"
+src_dir=$(ls)
+if [ $(echo "$src_dir" | wc -l) -ne 1 ]; then
+  echo "ERROR: unexpected source structure:\n$src_dir" >&2
+  exit 1
+fi
+
+cd "$src_dir"
+cargo vendor
+if [ $? -ne 0 ]; then
+  echo "ERROR: cargo vendor failed" >&2
+  exit 1
+fi
+
+# replace cargo package version with @@VERSION@@
+perl -pi -e 'BEGIN { undef $/;} s/(\[\[package\]\]\nname\s*=\s*"'"$cargo_package"'"\nversion\s*=\s*")[^"]+/$1\@\@VERSION\@\@/m' Cargo.lock
+
+cd ..
+tar cJf "$pkg_dir/$crates_file" "$src_dir"/{Cargo.lock,vendor}
+
+# vim: expandtab shiftwidth=2 tabstop=2
================================================================

---- gitweb:

http://git.pld-linux.org/gitweb.cgi/packages/zoxide.git/commitdiff/0dc3cd0e88658333c1e8a64f464790582d227865



More information about the pld-cvs-commit mailing list